﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;

namespace BreadcrumbWPF
{
    public class MainViewModel : ViewModelBase
    {
        private MyItem currentItem;
        private string path;
        private string correctPath;
        private ObservableCollection<MyItem> items;
        private MyItem root;

        public MainViewModel()
        {
            this.items = new ObservableCollection<MyItem>();
            var item1 = new MyItem() { Header = "Item 1" };
            item1.Items.Add(new MyItem() { Header = "Item 1.1" });
            this.items.Add(item1);
            this.items.Add(new MyItem() { Header = "Item 2", CanSelect = false });
            this.root = new MyItem() { Header = "Root" };
            this.correctPath = this.root.Header;
        }

        public ObservableCollection<MyItem> Items
        {
            get
            {
                return this.items;
            }
        }

        public MyItem Root
        {
            get
            {
                return this.root;
            }
            set
            {
                this.root = value;
            }
        }

        public string Path
        {
            get
            {
                return this.path;
            }
            set
            {
                if (this.path != value)
                {
                    this.path = value;
                    this.OnPropertyChanged("Path");
                }
            }
        }

        public MyItem CurrentItem
        {
            get
            {
                return this.currentItem;
            }
            set
            {
                if (this.currentItem != value)
                {
                    if (value != null && !value.CanSelect)
                    {
                        this.Path = this.correctPath;
                    }
                    else
                    {
                        this.correctPath = string.IsNullOrEmpty(this.Path) ? this.root.Header : this.Path;
                        this.currentItem = value;
                        this.OnPropertyChanged("CurrentItem");
                    }
                }
            }
        }
    }
}
